/* file user.c */
#include <fork.h>
#include <io.h>
#include <stdlib.h>
#include <math.h>   /* the user has to declare not only the */
#include "tdr.h"    /* libraries s(he) uses but also the    */
#include "pqueue.h"	/* used by the skeleton                 */ 

/* skeleton pqs int */
#define int_pqs_printData(message,ptritem) {\
	pprintf("%s %d\n",message,*ptritem);}
#include "int_pqs.h"

/* skeleton pqs float */
#define float_pqs_printData(message,ptritem) {\
	printf("%s %f\n",message,(int)*ptritem);}
#include "float_pqs.h"

#define initData(type_of_i, e, i) {\
    if (e = (type_of_i *) shmalloc( sizeof( type_of_i ))) \
			*e = i;\
     else {\
      pprintf("Error allocating data\n");\
      exit(1);\
    }\
  }

#define takeDecision(decision) (decision = abs(rand()) % 2)

sh pqueue_type * pq;
sh int seed, times;

void getInputData(int * seed, int * times) {

  if (!$) {
    pprintf("\nseed (odd positive number, please) = "); 
    scanf("%d",seed);
    pprintf("\ntimes = "); 
    scanf("%d",times);
  }
  barrier;
  srand(2*$*(*seed)+1);
}

void randomAccessTestInt(void) {
  pr int i, decision, *e; 

  for (i=__PROC_NR__; i<times; i+=__STARTED_PROCS__) {
		takeDecision(decision);
    pprintf("decision %d \n",decision);
    if (decision) { /* pqueue_put */
      initData(int, e,i); 
      pqueue_put( pq, (char *) e );
    }
    else { /* pqueue_get */
    if (e = (int *) pqueue_get( pq )) {
			pprintf("got: %d \n",*e);
      shfree(e);
    }
    else pprintf("can not catch an element\n");
    }
  }

 int_pqs_scan( pq );
}

void emptyOutTheQueueInt(void) {
  pr int *e; 

	 while (pq->size != 0) {
    if (e = (int *) pqueue_get( pq )) {
      pprintf("Get element %d\n", (int) *e); 
      shfree(e);
    }
    else pprintf("can not catch an element\n");
  }
}

void randomAccessTestFloat(void) {
  pr int i, decision;
	float *e; 

  for (i=__PROC_NR__; i<times; i+=__STARTED_PROCS__) {
		takeDecision(decision);
    pprintf("decision %d \n",decision);
    if (decision) { /* pqueue_put */
      initData(float, e, (float) i); 
      pqueue_put( pq, (char *) e );
    }
    else { /* pqueue_get */
    if (e = (float *) pqueue_get( pq )) {
			pprintf("got: %d \n",(int) *e);
      shfree(e);
    }
    else pprintf("can not catch an element\n");
    }
  }
 float_pqs_scan( pq );
}

void emptyOutTheQueueFloat(void) {
  pr float *e; 

	 while (pq->size != 0) {
    if (e = (float *) pqueue_get( pq )) {
      pprintf("Get element %d\n", (int) *e); 
      shfree(e);
    }
    else pprintf("can not catch an element\n");
  }
}

void main( void )
{
	getInputData(&seed,&times);

  pprintf("starting with int queue: shared heap available memory = %d \n",shavail());
  pqueue_init(&pq); 
  pprintf("Initialization completed\n");
  int_pqs_scan(pq);
	pprintf("executing with seed = %d, %d times ...\n",seed,times);
	randomAccessTestInt();
	emptyOutTheQueueInt();
	pqueue_close(&pq);
	pprintf("finish: shared heap available memory = %d \n",shavail());
	barrier;

  pprintf("starting with float queue: shared heap available memory = %d \n",shavail());
  pqueue_init(&pq); 
  pprintf("Initialization completed\n");
  float_pqs_scan(pq);
	pprintf("executing with seed = %d, %d times ...\n",seed,times);
	randomAccessTestFloat();
	emptyOutTheQueueFloat();
	pqueue_close(&pq);
	pprintf("finish: shared heap available memory = %d \n",shavail());
	barrier;
}
